C ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

      INTEGER FUNCTION clen(cstr)

C @(#)Function: clen                 Author: R.A. Jansen -- Mar  8, 1995
C @(#)
C @(#)  Purpose: Return as the function value  the actual (as opposed to
C @(#)    the declared) length  of an input character string.  If string
C @(#)    'cstr' is blank, the return value will be 0.
C @(#)
C @(#)  Calling sequence: i = clen(cstr)   where string 'cstr' can be of
C @(#)    arbitrary declared length (internally: CHARACTER*(*) ).
C @(#)
C @(#)  Dependencies:     (none)
C @(#)
C @(#)  Revision history: May 20, 2008 [RAJ] -- expanded documentation.
C @(#)------------------------------------------------------------------

      CHARACTER*(*) cstr
      INTEGER	i

C --- Search from declared end of array for first non-blank character...
      DO i=LEN(cstr),1,-1
         clen = i
         IF (cstr(clen:clen).NE.CHAR(32)) RETURN
      ENDDO

C --- Character string only has blanks; return zero length...
      clen = 0

      RETURN
      END


